/*============================================================================*\
|                                                                              |
|                         =S= DPWS toolkit Samples                             |
|                                                                              |
|           ->>  Copyright 2004-2006 Schneider Electric SA <<-                 |
|                                                                              |
|                                                                              |
|                                + File info:                                  |
|                                              $Revision: 1.3.2.3 $
|                                              $Date: 2007/03/09 15:48:27 $
\*============================================================================*/
#include "dpws.h"
#include "fileio.h"

#include "prjStub.h"
#include "prj.nsmap"

#define HOMECINEMA_NS "http://www.schneider-electric.com/DPWS/2006/03/Training/HomeCinema"
#define DISPLAY_TYPE "Display"

static char command[32], param1[32];
static int status, nbParams;

static unsigned char buffer[1000000];

static short getServiceEndpoint(struct dpws *dpws, short deviceProxy)
{
	int nbServices;
	short * serviceProxies = dpws_get_services(dpws, deviceProxy, HOMECINEMA_NS, DISPLAY_TYPE, &nbServices);
	if (nbServices != 1) {
		if (nbServices <= 0)
			printf("No service endpoint found\n");
		else
			printf("Too many service endpoints found\n");
		dpws_end(dpws);
		return -1;
	}
	dpws_pin_proxy(serviceProxies[0]);
	return serviceProxies[0];
}

void projectorClient(struct dpws *dpws, short deviceProxy)
{
	short serviceProxy;
	struct wsa_endpoint_ref * servEndPt;

	soap_set_mode(&dpws->soap, SOAP_ENC_MTOM);	// To be able to send MTOM attachments

	printf ("\nProjector device type commands (Q to quit this menu):\n\n");
	printf ("Display <jpeg image name>\n");

	// command loop
	for (;;) {
		
		printf ("\nEnter command:\n");
		nbParams = scanf("%32s", command);
		if (nbParams == 0) {
			printf("Type mismatch !\n");
			continue;
		}
		
		// finding service endpoint
		serviceProxy = getServiceEndpoint(dpws, deviceProxy);
		if (serviceProxy < 0) {
			printf ("Could not find service.\n");
			return;
		}
		servEndPt = dpws_get_default_endpoint_reference(dpws, serviceProxy);
		
		// Command parsing
		if (!stricmp(command, "Display")) {
			nbParams = scanf("%32s", param1);
			if (nbParams != 1)
				printf("Bad parameter count !\n");
			else {
				struct prj__AttachmentType image;
				
			  	image.Param.__ptr = buffer;
			  	image.Param.__size = (int)readfile(param1, image.Param.__ptr);
				if (image.Param.__size > 0) {
			  		image.Param.id = NULL;
			  		image.Param.type = "image/jpeg";
			  		image.Param.options = NULL;

					status = dpws_send___prj__DisplayImage(dpws, servEndPt, &image);
				}
				else
					printf("Cannot read file for attachment.\n");
			}
		}
		else if ( stricmp(command,"Q")==0 ){
			return;
		}
		else
			printf("Command Unknown\n");
		if (status)
			fprintf(stderr, dpws_get_error_msg(dpws));
		dpws_end(dpws);
		dpws_release_proxy(serviceProxy);
	}
}