#include "fileio.h"
#include <string.h>

#define BYTESCHUNK 4096

size_t readfile(const char* filename, unsigned char* bytes) {
	FILE* f = fopen(filename, "rb");
	size_t res = 0, nread;
	if (!f) return -1;
	while ((nread = fread(bytes+res, 1, BYTESCHUNK, f)) == BYTESCHUNK) {
		res += nread;
	}
	if (nread >= 0 && feof(f))
		res += nread;
	else res = -1;
	fclose(f);
	return res;	
}

int writefile(const char* filename, unsigned char* bytes, size_t len) {
	FILE* f = fopen(filename, "wb");	
	size_t nwritten = 0;
	if (!f) return -1;
	while (1) {
		size_t n = len - nwritten;
		if (n > BYTESCHUNK) {
			fwrite(bytes+nwritten, 1, BYTESCHUNK, f);
			nwritten += BYTESCHUNK;
		} else {
			fwrite(bytes+nwritten, 1, n, f);
			fclose(f);
			return 0;	
		}
	}
}

int readintfromfile(const char* filename) {
	FILE* f = fopen(filename, "r");
	char buf[100];
	int val;
	size_t n;
	if (!f || (n = fread(buf, 1, 99, f)) <= 0) {
		val = 0;
	} else {
		buf[n] = '\0';
		sscanf(buf, "%d", &val);
	}
	if (f) fclose(f);
	return val;
}

int writeinttofile(int val, const char* filename) {
	FILE* f = fopen(filename, "w");
	char buf[100];
	sprintf(buf, "%d", val);
	fwrite(buf, 1, strlen(buf), f);
	fclose(f);
	return val;
}