/*============================================================================*\
|                                                                              |
|                         =S= DPWS toolkit Samples                             |
|                                                                              |
|           ->>  Copyright 2004-2006 Schneider Electric SA <<-                 |
|                                                                              |
|                                                                              |
|                                + File info:                                  |
|                                              $Revision: 1.5.4.1 $
|                                              $Date: 2007/02/13 10:03:09 $
\*============================================================================*/
#include <pthread.h>
#include <stdio.h>

#include "dpws.h"

pthread_t bootThread = NULL;

static void* runServer(struct dpws * dpws)
{
	int status = DPWS_OK;

    while (1) {
		status = dpws_accept(dpws);
		if (status) {
			if (status != DPWS_ERR_SERVER_STOPPED)
				fprintf(stderr, dpws_get_error_msg(dpws));
			goto exit;
		}
		dpws_serve(dpws);
		dpws_end(dpws);
	}
	
exit:
	// Clean the DPWS registry
	dpws_shutdown(dpws);
	return NULL;
}

int initServer(struct dpws *dpws)
{
	int status = dpws_server_init(dpws, NULL);
	if (status)
		fprintf(stderr, dpws_get_error_msg(dpws));
	return status;
}

int bootServer(struct dpws *dpws)
{
	int status = 0;
	if ((status = pthread_create(&bootThread, NULL, runServer, dpws))) {
	    fprintf (stderr, "Thread Creation ERROR (%d) - bootServer()\n", status);
	    return status;
	}
	return 0;
}

void stopServer()
{
	dpws_stop_server(1000);
	// wait for the master thread to exit
	pthread_join(bootThread, NULL);
}

