/*============================================================================*\
|                                                                              |
|                         =S= DPWS toolkit Samples                             |
|                                                                              |
|           ->>  Copyright 2004-2006 Schneider Electric SA <<-                 |
|                                                                              |
|                                                                              |
|                                + File info:                                  |
|                                              $Revision: 1.6.4.1 $
|                                              $Date: 2007/02/13 10:03:09 $
\*============================================================================*/
#include <windows.h>
#include <stdio.h>

#include "dpws.h"

HANDLE bootThread = NULL;

static DWORD WINAPI runServer(struct dpws *);
static DWORD WINAPI serve(struct dpws *);

int initServer(struct dpws *dpws)
{
	int status = dpws_server_init(dpws, NULL);
	if (status)
		fprintf(stderr, dpws_get_error_msg(dpws));
	return status;
}

int bootServer(struct dpws *dpws)
{
	bootThread = CreateThread(NULL, 0, runServer, dpws, 0, NULL);
	if (bootThread == NULL) {
	    fprintf (stderr, "Thread Creation ERROR (%d) - bootServer()\n", GetLastError());
	    return -1;
	}
	return 0;
}

void stopServer()
{
	dpws_stop_server(1000);
	// wait for the master thread to exit
	WaitForSingleObject(bootThread, 2000);
	CloseHandle(bootThread);
}

static DWORD WINAPI runServer(struct dpws * dpws)
{
	int status = DPWS_OK;

    while (TRUE) {
		status = dpws_accept(dpws);
		if (status) {
			if (status != DPWS_ERR_SERVER_STOPPED)
				fprintf(stderr, dpws_get_error_msg(dpws));
			goto exit;
		}
		dpws_serve(dpws);
		dpws_end(dpws);
	}
	
exit:
	// dpws_shutdown() is performed by the DLL
	return 0;
}