/*============================================================================*\
|                                                                              |
|       =S= Device Profile for Web Services C Toolkit (DPWS toolkit)           |
|                                                                              |
|           ->>  Copyright 2004-2007 Schneider Electric SA <<-                 |
|                                                                              |
|                                                                              |
|                                + File info:                                  |
|                                              $Revision: 1.31.4.2 $
|                                              $Date: 2007/04/20 12:44:13 $
\*============================================================================*/
 
#ifndef DISCOVERY_H
# define DISCOVERY_H

# include "tools.h"
# include "config.h"

/*----------------------------------------------------------------------------*\
 *                                SOAP over UDP                               *
\*----------------------------------------------------------------------------*/
int is_new_message(char * uuid);

/*******************************************************************************
*                                   RUNTIME                                    *
*******************************************************************************/
unsigned short new_app_seq_msg_nb();
int initDiscovery();
void uninitDiscovery();
int schedule_discovery_msg(scheduler_t *pScheduler, short msgType, char * req_id,
	struct device *device, int (*handler) (struct dpws*, void *), short hrefLock);

/*******************************************************************************
*                       WS-DISCOVERY STUB & SKELETON                           *
*******************************************************************************/
#ifdef SOAP_FMAC3
# undef SOAP_FMAC3
#endif
#define SOAP_FMAC3 static
# include "gen/discoveryStub.h"

int wsd_mcast_recv(struct dpws *dpws);
int wsd_ucast_recv_probematch(struct dpws *dpws);
int wsd_ucast_recv_resolvematch(struct dpws *dpws);
int wsd_serve_directed_probe(struct dpws *dpws);

int wsd_process(struct dpws *dpws);

int send_hello(struct dpws* dpws, handle_s * handle);
int send_bye(struct dpws* dpws, handle_s * handle);
int send_probe(struct dpws * dpws, struct wsd__ProbeType *body);
char* call_directed_probe(struct dpws * dpws, char * address, struct wsd__ProbeType *body);
int send_resolve(struct dpws * dpws, struct wsa_endpoint_ref *discovery_endpoint);

#endif
