/*============================================================================*\
|                                                                              |
|       =S= Device Profile for Web Services C Toolkit (DPWS toolkit)           |
|                                                                              |
|           ->>  Copyright 2004-2007 Schneider Electric SA <<-                 |
|                                                                              |
|                                                                              |
|                                + File info:                                  |
|                                              $Revision: 1.50.2.5 $
|                                              $Date: 2007/03/23 16:41:34 $
\*============================================================================*/
 
/*******************************************************************************
*                            WS-METADATA STUB & SKELETON                       *
*******************************************************************************/
/* soapC.c
   Generated by gSOAP 2.6.2 from metadata.gsoap
   Copyright (C) 2001-2004 Genivia, Inc. All Rights Reserved.
   This software is released under the gSOAP public license and GPL.
   See README.txt for further details.
*/
#include "metadata.h"
#include "tools.h"
#include "config.h"

extern struct dpws_config tk_config;
extern short cache_lock_handle;
extern handlePool_t registryPool;

/*******************************************************************************
*                                 MARSHALLING                                  *
*******************************************************************************/

#define WITH_NOGLOBAL
#ifdef SOAP_FMAC3
# undef SOAP_FMAC3
#endif
#define SOAP_FMAC3 static
#include "gen/metadataC.c"
#include "gen/metadata.nsmap"
#undef WITH_NOGLOBAL

/*******************************************************************************
*                                    STUB                                      *
*******************************************************************************/
#include "gen/metadataClient.c"

/*******************************************************************************
*                                  SKELETON                                    *
*******************************************************************************/
#include "gen/metadataServer.c"

/******************************************************************************\
 *                                                                            *
 * Service Operations (Server-side)                                           *
 *                                                                            *
\******************************************************************************/

static struct wdp__HostServiceType * build_hosting_section(struct dpws *dpws, 
														   struct service_endpoint* endpoint, 
														   dyn_array* types, 
														   char* service_id) 
{
	struct wdp__HostServiceType * section;
	int i = 0;
	section = (struct wdp__HostServiceType *)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__HostServiceType));
	soap_default_wdp__HostServiceType(dpws_dpws2soap(dpws), section);
	
	section->__sizeEndpointReference = endpoint->service_ports.nb;
	section->wsa__EndpointReference =
		(struct wsa_endpoint_ref **)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wsa_endpoint_ref *) * endpoint->service_ports.nb);
	for (; i < endpoint->service_ports.nb; i++) {
		section->wsa__EndpointReference[i] = (struct wsa_endpoint_ref *)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wsa_endpoint_ref));
		dpws_build_local_endpoint_ref(section->wsa__EndpointReference[i], *(short *)get_entry(&endpoint->service_ports, i));
	}

	section->Types = types;
	section->ServiceId = service_id;
	return section;
}

int __wst__Get(struct dpws *dpws, void *request, struct __wst__AnyXmlType *body)
{
	struct _wsm__Metadata *response = soap_malloc(dpws_dpws2soap(dpws), sizeof(struct _wsm__Metadata));
	struct _wsm__MetadataSection * section = NULL;
	struct service_endpoint * endpoint = get_endpoint(dpws->href_endpoint);
	_wdp__ThisModel * model = NULL;
	_wdp__ThisDevice * device = NULL;
	struct _wdp__Relationship * relationship;
	struct wsdl_info * wsdlInfo;
	int i;
	struct service_class *servClass = (struct service_class *)getObject(&registryPool, endpoint->hrefServiceClass);
	
//    if(1) return SOAP_FAULT;



	body->__type = SOAP_TYPE__wsm__Metadata;
	body->__any = response;
	response->__sizeMetadataSection = 0;
	response->wsm__MetadataSection = soap_malloc(dpws_dpws2soap(dpws), sizeof(struct _wsm__MetadataSection *) * (3 + count_tns_wsdl(endpoint))); // allocate the maximun anyway
	
	/* Sections only for device endpoints */
	if (!endpoint->service_id)
	{
		/* DPWS: This model */
		struct device_class * devClass = (struct device_class *)getObject(&registryPool, endpoint->device->hrefClass);
		
		section = response->wsm__MetadataSection[response->__sizeMetadataSection++]
				= (struct _wsm__MetadataSection*)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct _wsm__MetadataSection));
		soap_default__wsm__MetadataSection(dpws_dpws2soap(dpws), section);
		section->Dialect = WDP_MODEL_URI;
		section->__type = SOAP_TYPE__wdp__ThisModel;
		section->_any = model = (_wdp__ThisModel*)soap_malloc(dpws_dpws2soap(dpws), sizeof(_wdp__ThisModel));
		soap_default__wdp__ThisModel(dpws_dpws2soap(dpws), model);
		model->__sizeManufacturer = 1;
		model->Manufacturer = (struct wdp__LocalizedStringType **)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__LocalizedStringType *));
		model->Manufacturer[0] = (struct wdp__LocalizedStringType *)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__LocalizedStringType));
		soap_default_wdp__LocalizedStringType(dpws_dpws2soap(dpws), model->Manufacturer[0]);
		model->Manufacturer[0]->__item = devClass->manufacturer;
		model->ManufacturerUrl = devClass->manufacturer_url;
		model->__sizeModelName = 1;
		model->ModelName = (struct wdp__LocalizedStringType **)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__LocalizedStringType *));
		model->ModelName[0] = (struct wdp__LocalizedStringType *)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__LocalizedStringType));
		soap_default_wdp__LocalizedStringType(dpws_dpws2soap(dpws), model->ModelName[0]);
		model->ModelName[0]->__item = devClass->model_name;
		model->ModelNumber = devClass->model_number;
		model->ModelUrl = devClass->model_url;
		model->PresentationUrl = devClass->presentation_url;
		
		/* DPWS: This device */
		
		section = response->wsm__MetadataSection[response->__sizeMetadataSection++]
				= (struct _wsm__MetadataSection*)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct _wsm__MetadataSection));
		soap_default__wsm__MetadataSection(dpws_dpws2soap(dpws), section);
		section->Dialect = WDP_DEVICE_URI;
		section->__type = SOAP_TYPE__wdp__ThisDevice;
		section->_any = device = (_wdp__ThisDevice*)soap_malloc(dpws_dpws2soap(dpws), sizeof(_wdp__ThisDevice));
		soap_default__wdp__ThisDevice(dpws_dpws2soap(dpws), device);
		device->__sizeFriendlyName = 1;
		device->FriendlyName = (struct wdp__LocalizedStringType **)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__LocalizedStringType *));
		device->FriendlyName[0] = (struct wdp__LocalizedStringType *)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__LocalizedStringType));
		soap_default_wdp__LocalizedStringType(dpws_dpws2soap(dpws), device->FriendlyName[0]);
		device->FriendlyName[0]->__item = endpoint->device->friendly_name;
		device->FirmwareVersion = endpoint->device->firmware_version;
		device->SerialNumber = endpoint->device->serial_number;
	}
	
	/* DPWS: Hosting */

	// TODO: Check create a per-hosted services namespace table ?
	dpws_set_namespaces(
						dpws,
						((struct device_class *)getObject(
										&registryPool,
										endpoint->device->hrefClass)
										)->services_namespaces.tab
						);

	section = response->wsm__MetadataSection[response->__sizeMetadataSection++]
			= (struct _wsm__MetadataSection*)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct _wsm__MetadataSection));
	soap_default__wsm__MetadataSection(dpws_dpws2soap(dpws), section);
	section->Dialect = WDP_HOSTING_URI;
	section->__type = SOAP_TYPE__wdp__Relationship;
	section->_any = relationship = (struct _wdp__Relationship*)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct _wdp__Relationship));
	soap_default__wdp__Relationship(dpws_dpws2soap(dpws), relationship);
	relationship->Type = WDP_RELATIONSHIP_HOST_TYPE_URI;
		
	// TODO: AM - check uuid vs. service_id issue
	if (endpoint->service_id) {	// hosted service
		relationship->Host = build_hosting_section(dpws, endpoint, get_string_device_types(endpoint->device), NULL);
		relationship->__sizeHosted = 1;
		relationship->Hosted = (struct wdp__HostServiceType **)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wdp__HostServiceType *));			
		relationship->Hosted[0] = build_hosting_section(dpws, endpoint, get_string_service_types(endpoint), endpoint->service_id);
	}
	else {	// device
		struct service_endpoint * w_endpoint;
		int nendpoints = endpoint->device->service_count;
		relationship->Hosted = (struct wdp__HostServiceType **)soap_malloc(dpws_dpws2soap(dpws), nendpoints * sizeof(struct wdp__HostServiceType *));			
		nendpoints = 0; // recount to ignore device
		for (w_endpoint = endpoint->device->hosted_services; w_endpoint ; w_endpoint = w_endpoint->next) {
			if (w_endpoint->service_id)	// ignore device	// TODO : filter differently
				relationship->Hosted[nendpoints++] = build_hosting_section(dpws, w_endpoint, get_string_service_types(w_endpoint), w_endpoint->service_id);
		}
		relationship->__sizeHosted = nendpoints;
		if (nendpoints == 0)	// must at least have one host or hosted 
			relationship->Host = build_hosting_section(dpws, endpoint, get_string_device_types(endpoint->device), NULL);
	}

	/* WS-MetadataExchange: WSDL */
	// NOTE: only location currently supported
	
	for (i = 0; i < servClass->wsdl_files.nb; i++)
	{
		wsdlInfo = (struct wsdl_info *)get_entry(&servClass->wsdl_files, i);
		
		section = response->wsm__MetadataSection[response->__sizeMetadataSection++]
				= (struct _wsm__MetadataSection*)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct _wsm__MetadataSection));
		soap_default__wsm__MetadataSection(dpws_dpws2soap(dpws), section);
		section->Dialect = WSDL_URI;
		section->Identifier = wsdlInfo->target_ns;
		section->wsm__Location = wsdlInfo->location;
	}
	
	// NOTE: not supported
	//	- schemas are supposed to be referenced by WSDL
	// 	- WS-Policy: the only currently supported is SoapHttpRequestReplyAddress
	//	  which must be known to ask for metadata...
	return SOAP_OK;
}

int __wsm__Get(struct dpws* dpws, void* dummy, struct wsm__AnyXmlType * response)
{
	return WSA_ERR_ACTION_NOT_SUPPORTED;
}

static char* find_localized_entry(struct wdp__LocalizedStringType* *entries, int entry_nb, char *preferred_lang)
{
	int i, p_index = -1, d_index = -1, e_index = -1, ret = -1;
	char * lang;

	// Status (if more than one take the one without @lang or in english (first of the 2)
	for (i = 0; i < entry_nb; i++) {
		lang = entries[i]->xml__lang;
		if (!lang)
			d_index = i;
		else if (preferred_lang && !strcmp(lang, preferred_lang))
			p_index = i;
		else if (!strncmp(lang, "en", 2))
			e_index = i;		
	}
	if (p_index >= 0)	// take first the toolkit preferred language
		ret = p_index;
	else if (d_index >= 0)	// then the one without language
		ret = d_index;
	else if (e_index >= 0)	// then english
		ret = e_index;
	else if (entry_nb > 0)	// finally take first
		ret = 0;
		
	return ret < 0 ? NULL : entries[ret]->__item;
}

int get_endpoint_metadata(struct dpws* dpws, short href, struct device_proxy * device, BOOLEAN update, struct model_info *model,
		struct device_info *dev_info, dyn_array* host_endpoints, dyn_array* services, dyn_array* wsdlList)
{
	struct __wst__AnyXmlType response;
	struct _wsm__Metadata * out;
	int i;

	if (dpws_call___wst__Get(dpws, get_default_EPR(dpws, href), NULL, NULL, &response))
		return dpws_dpws2soap(dpws)->error;
	out = (struct _wsm__Metadata *)response.__any;
	
	for (i = 0; i < out->__sizeMetadataSection; i++) {
		struct _wsm__MetadataSection *section = out->wsm__MetadataSection[i];
		if (!strcmp(WDP_MODEL_URI, section->Dialect) && model) {
			_wdp__ThisModel * this_model;
			if (!section->_any)
				return DPWS_ERR_UNSUPPORTED_METADATA_SECTION;
			this_model = (_wdp__ThisModel *)section->_any;
			// manufacturer (if more than one take the one without @lang or in english (first of the 2)
			model->manufacturer = find_localized_entry(this_model->Manufacturer, this_model->__sizeManufacturer, tk_config.preferred_lang);
			// model name (if more than one take the one without @lang or in english (first of the 2)
			model->model_name = find_localized_entry(this_model->ModelName, this_model->__sizeModelName, tk_config.preferred_lang);
			// other fields
			model->manufacturer_url = this_model->ManufacturerUrl;
			model->model_number = this_model->ModelNumber;
			model->model_url = this_model->ModelUrl;
			model->presentation_url = this_model->PresentationUrl;
		}
		if (!strcmp(WDP_DEVICE_URI, section->Dialect) && dev_info) {
			_wdp__ThisDevice * this_device;
			if (!section->_any)
				return DPWS_ERR_UNSUPPORTED_METADATA_SECTION;
			this_device = (_wdp__ThisDevice *)section->_any;
			dev_info->friendly_name = find_localized_entry(this_device->FriendlyName, this_device->__sizeFriendlyName, tk_config.preferred_lang);
			dev_info->firmware_version = this_device->FirmwareVersion;
			dev_info->serial_number = this_device->SerialNumber;
		}
		if (!strcmp(WDP_HOSTING_URI, section->Dialect)) {
			struct _wdp__Relationship * relationship;
			int j;
			if (!section->_any)
				return DPWS_ERR_UNSUPPORTED_METADATA_SECTION;
			relationship = (struct _wdp__Relationship *)section->_any;
			if (strcmp(relationship->Type, WDP_RELATIONSHIP_HOST_TYPE_URI)) continue;
			if (host_endpoints && relationship->Host) {
				// no need to perform a deep copy of the EPR since already allocated on the gSOAP heap, but need to add the final null...
				host_endpoints->nb = host_endpoints->size = relationship->Host->__sizeEndpointReference;
				host_endpoints->tab = soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wsa_endpoint_ref *) * (host_endpoints->nb + 1));
				memcpy(host_endpoints->tab, relationship->Host->wsa__EndpointReference, sizeof(struct wsa_endpoint_ref *) * host_endpoints->nb); 
				memset((struct wsa_endpoint_ref *)host_endpoints->tab + host_endpoints->nb, 0, sizeof(struct wsa_endpoint_ref *)); 
			}
			// Cache update
			lock(cache_lock_handle);			
			if (services) 
				services->inc = relationship->__sizeHosted;
			for (j = 0; j < relationship->__sizeHosted; j++) {
				struct wdp__HostServiceType *hosted;
				hosted = relationship->Hosted[j];
				if (update) {
					add_service_proxy(device, hosted->wsa__EndpointReference, hosted->__sizeEndpointReference, hosted->Types, hosted->ServiceId);
					device->hosted_retrieved = TRUE;
				}
				if (services) {
					struct service_info* s_info = (struct service_info *)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct service_info));
					*(struct service_info **)new_entry(dpws, services) = s_info;
					// no need to perform a deep copy of the EPR since already allocated on the gSOAP heap, but need to add the final null...
					s_info->endpoints = soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wsa_endpoint_ref *) * (hosted->__sizeEndpointReference + 1));
					memcpy(s_info->endpoints, hosted->wsa__EndpointReference, sizeof(struct wsa_endpoint_ref *) * hosted->__sizeEndpointReference); 
					memset(s_info->endpoints + hosted->__sizeEndpointReference, 0, sizeof(struct wsa_endpoint_ref *)); 
					s_info->service_id = hosted->ServiceId;
				}
			}
			unlock(cache_lock_handle);
		}
		if (!strcmp(WSDL_URI, section->Dialect) && wsdlList) {
			struct wsdl_info * w_wsdl;
			if (!section->wsm__Location)
				return DPWS_ERR_UNSUPPORTED_METADATA_SECTION;
			w_wsdl = (struct wsdl_info *)soap_malloc(dpws_dpws2soap(dpws), sizeof(struct wsdl_info)); 
			w_wsdl->target_ns = section->Identifier;
			w_wsdl->location = section->wsm__Location;
			*(struct wsdl_info **)new_entry(dpws, wsdlList) = w_wsdl;
		}
	}
	return SOAP_OK;
}

